LibreOffice LibreOffice 25.2 SDK API Reference

Public Member Functions | List of all members
XSlideShow Interface Reference

Slide show interface to perform slide show presentations. More...

`import"XSlideShow.idl";`

Inheritance diagram for XSlideShow:

## Public Member Functions
boolean | nextEffect ()
| Trigger the next effect of the slide show. More...
boolean | previousEffect ()
| Undo the last effect in the main sequence of the slide show. More...
boolean | startShapeActivity ([in] ::com::sun::star::drawing::XShape xShape)
| Start a shape-intrinsic animation or activity. More...
boolean | stopShapeActivity ([in] ::com::sun::star::drawing::XShape xShape)
| Stop a shape-intrinsic animation or activity. More...
void | displaySlide ([in] ::com::sun::star::drawing::XDrawPage xSlide, [in] ::com::sun::star::drawing::XDrawPagesSupplier xDrawPages, [in] ::com::sun::star::animations::XAnimationNode AnimationNode, [in] sequence< ::com::sun::star::beans::PropertyValue > aProperties)
| Jump to the given slide. More...
boolean | pause ([in] boolean bPauseShow)
| Change the pause state of the slide show. More...
::com::sun::star::drawing::XDrawPage | getCurrentSlide ()
| Query the currently displayed slide. More...
void | registerUserPaintPolygons ([in] ::com::sun::star::lang::XMultiServiceFactory xDocFactory)
| Register drawn polygons in presentation mode. More...
boolean | setProperty ([in] ::com::sun::star::beans::PropertyValue aShowProperty)
| Change a property of the slide show. More...
boolean | addView ([in] XSlideShowView xView)
| Add a view to the slide show. More...
boolean | removeView ([in] XSlideShowView xView)
| Remove view from the slide show. More...
boolean | update ([out] double nNextTimeout)
| Update the animations. More...
void | addSlideShowListener ([in] XSlideShowListener xListener)
| Add a slide show listener. More...
void | removeSlideShowListener ([in] XSlideShowListener xListener)
| Revoke a previously registered slide show listener. More...
void | addShapeEventListener ([in] XShapeEventListener xListener, [in] ::com::sun::star::drawing::XShape xShape)
| Add a shape event listener. More...
void | removeShapeEventListener ([in] XShapeEventListener xListener, [in] ::com::sun::star::drawing::XShape xShape)
| Revoke a previously registered shape event listener. More...
void | setShapeCursor ([in] ::com::sun::star::drawing::XShape xShape, [in] short nPointerShape)
| Set a special mouse cursor for a shape. More...
boolean | createLOKSlideRenderer ([out] long nViewWidth, [out] long nViewHeight, [in] boolean bRenderMasterPage, [in] boolean bRenderBackground, [in] ::com::sun::star::drawing::XDrawPage xSlide, [in] ::com::sun::star::drawing::XDrawPagesSupplier xDrawPages, [in] ::com::sun::star::animations::XAnimationNode xRootNode)
| Used to create a slide renderer for the Online client. More...
boolean | renderNextLOKSlideLayer ([in] hyper nBufferPointer, [out] boolean bIsBitmapLayer, [out] string rJsonMsg)
| Used to renderer a slide layer for the Online client. More...
Public Member Functions inherited from XInterface
any | queryInterface ([in] type aType)
| queries for a new interface to an existing UNO object. More...
void | acquire ()
| increases the reference counter by one. More...
void | release ()
| decreases the reference counter by one. More...

## Detailed Description

Slide show interface to perform slide show presentations.

This interface provides the necessary methods to run and control a slide show from a given set of XDrawPage slides. The slide show can be displayed simultaneously on multiple targets.

Note: To control a running slide show inside a presentation, please use XPresentation2 and XSlideShowController.

Since
  OOo 3.0

## Member Function Documentation

## ◆ addShapeEventListener()

void addShapeEventListener | ( | [in] XShapeEventListener | xListener,
|  | [in] ::com::sun::star::drawing::XShape | xShape
| ) |  |

Add a shape event listener.

This method adds a listener to the slide show, which will get notified when a mouse click is performed on the given shape. This can be used by clients of the slide show to trigger external actions, such as jumps to different slides.

Parameters

  xListener | Listener to add.
  xShape | Shape to register a listener for.

## ◆ addSlideShowListener()

void addSlideShowListener | ( | [in] XSlideShowListener | xListener | ) |

Add a slide show listener.

This method adds a listener to the slide show, which will get notified when a registered shape is clicked upon, or a new slide is about to be displayed. Note that the listeners will not be notified, when the slide change is directly requested by one of the nextSlide(), previousSlide() or displaySlide() methods.

Parameters

  xListener | Listener to add.

## ◆ addView()

boolean addView | ( | [in] XSlideShowView | xView | ) |

Add a view to the slide show.

This method adds a view to the slide show. After successful completion of this method, the slide show will be visible on the added view, scaled according to the view's output area.

Parameters

  xView | The view to add

Returns
  `TRUE`, if the view has been successfully added. Otherwise, `FALSE` is returned (e.g. if the view is already added).

## ◆ createLOKSlideRenderer()

boolean createLOKSlideRenderer | ( | [out] long | nViewWidth,
|  | [out] long | nViewHeight,
|  | [in] boolean | bRenderMasterPage,
|  | [in] boolean | bRenderBackground,
|  | [in] ::com::sun::star::drawing::XDrawPage | xSlide,
|  | [in] ::com::sun::star::drawing::XDrawPagesSupplier | xDrawPages,
|  | [in] ::com::sun::star::animations::XAnimationNode | xRootNode
| ) |  |

Used to create a slide renderer for the Online client.

## ◆ displaySlide()

void displaySlide | ( | [in] ::com::sun::star::drawing::XDrawPage | xSlide,
|  | [in] ::com::sun::star::drawing::XDrawPagesSupplier | xDrawPages,
|  | [in] ::com::sun::star::animations::XAnimationNode | AnimationNode,
|  | [in] sequence< ::com::sun::star::beans::PropertyValue > | aProperties
| ) |  |

Jump to the given slide.

This method ends all effects on the current slide, displays a possible slide transition, followed by the given slide. If the current slide is equal to the requested slide here, this method does nothing (this especially means, that any currently active effects will remain running).

Parameters

  xSlide | The slide to display.
  xDrawPages | For future use.
  AnimationNode | The animation node determine the animations to display.
  aProperties | Sequence of property values, which influence the way the slide is displayed. Currently, the following values are recognized: name: Prefetch, value: com::sun::star::drawing::XDrawPage. When given, this slide is prepared in the background to be displayed next. The next call to displaySlide() with the given slide may be faster if there was enough time for prefetching. If the next call to displaySlide() uses a different slide, this will still work but will not have any performance improvements name: SkipAllMainSequenceEffects, value: boolean. When `TRUE` then all main sequence effects on the new slide are triggered. This is typically used when going back one effect leads to the previous slide. On that slide all effects have to be shown in order to continue the backward traveling. When `FALSE`, the default, then no main sequence effect is triggered. name: SkipSlideTransition, value: boolean. When `TRUE` then the slide transition animation, if there is any, is not displayed. This is typically used when going back one effect leads to the previous slide. Typically used together with SkipAllMainSequenceEffects also being `TRUE`. When `FALSE`, the default, then the slide transition effect, if it exists, is played.

## ◆ getCurrentSlide()

::com::sun::star::drawing::XDrawPage getCurrentSlide | ( |  | ) |

Query the currently displayed slide.

Returns
  the instance of the current slide. If there's no slide show running at the moment, this method returns an empty reference.

## ◆ nextEffect()

boolean nextEffect | ( |  | ) |

Trigger the next effect of the slide show.

This method triggers the next effect on the currently displayed slide. If there is currently no slide show running, this method does nothing. If there are no more effects on the current slide, a possible slide transition effect is issued and the next slide is displayed.

Returns
  `TRUE`, if the next effect was successfully triggered. This method returns `FALSE`, if there is no show running, the last effect on the last slide was already triggered, or the implementation failed to trigger the next effect.

## ◆ pause()

boolean pause | ( | [in] boolean | bPauseShow | ) |

Change the pause state of the slide show.

This method either pauses the slide show (all currently running effects are stopped), or starts a previously stopped show again (all paused effects start again).

Parameters

  bPauseShow | When `TRUE`, the show is paused. When `FALSE`, and the show was paused, it starts running at the paused position again.

Returns
  `TRUE`, if the requested action was successfully performed.

## ◆ previousEffect()

boolean previousEffect | ( |  | ) |

Undo the last effect in the main sequence of the slide show.

The current slide is displayed as if the last user-triggered effect has never been triggered. If there is no previous effect on the current slide then slideEnded(true) is called at the registered XSlideShowListener objects, which can then trigger a change to the previous slide. Note that this command is executed asynchronously. Multiple calls to update() may be necessary to complete its execution. If there is currently no slide show running, this method does nothing.

Returns
  `TRUE`, if the previous effect was successfully triggered. This method returns `FALSE`, if there is no show running, the first effect on the first slide was not yet triggered, or the implementation failed to trigger the previous effect.

## ◆ registerUserPaintPolygons()

void registerUserPaintPolygons | ( | [in] ::com::sun::star::lang::XMultiServiceFactory | xDocFactory | ) |

Register drawn polygons in presentation mode.

Parameters

  xDocFactory |

## ◆ removeShapeEventListener()

void removeShapeEventListener | ( | [in] XShapeEventListener | xListener,
|  | [in] ::com::sun::star::drawing::XShape | xShape
| ) |  |

Revoke a previously registered shape event listener.

Parameters

  xListener | Listener interface to revoke from being called.
  xShape | Shape for which the listener should be revoked.

## ◆ removeSlideShowListener()

void removeSlideShowListener | ( | [in] XSlideShowListener | xListener | ) |

Revoke a previously registered slide show listener.

Parameters

  xListener | Listener interface to revoke from being called.

## ◆ removeView()

boolean removeView | ( | [in] XSlideShowView | xView | ) |

Remove view from the slide show.

This method removes the given view from the slide show. After successful completion of this method, the slide show will cease to display on this view.

Parameters

  xView | View to remove

Returns
  `TRUE`, if the view was successfully removed, `FALSE` otherwise (e.g. if the view was not added in the first place).

## ◆ renderNextLOKSlideLayer()

boolean renderNextLOKSlideLayer | ( | [in] hyper | nBufferPointer,
|  | [out] boolean | bIsBitmapLayer,
|  | [out] string | rJsonMsg
| ) |  |

Used to renderer a slide layer for the Online client.

## ◆ setProperty()

boolean setProperty | ( | [in] ::com::sun::star::beans::PropertyValue | aShowProperty | ) |

Change a property of the slide show.

Parameters

  aShowProperty | Property values, which influence the way the slides are shown. Note that this might possibly be a subset of what is supported on show(). Currently, the following values are recognized: name: AutomaticAdvancement, value: double. When given, effects and slides are advanced automatically. The double value specifies the timeout between the end of one effect until the start of the next one. Negative values are truncated to zero here. When given, but with empty value, automatic advancement is disabled again. name: UserPaintColor, value: long. When given, the slide show will display a small stylus as the mouse cursor. When pressing the left mouse key, the user can paint a thin line in the given color. A changed property is effective immediately.

## ◆ setShapeCursor()

void setShapeCursor | ( | [in] ::com::sun::star::drawing::XShape | xShape,
|  | [in] short | nPointerShape
| ) |  |

Set a special mouse cursor for a shape.

This method requests the slide show to display a special cursor, whenever the mouse is hovering over the given shape.

Parameters

  xShape | Shape to display a special mouse cursor.
  nPointerShape | Type of mouse cursor to display. Must be one of the com::sun::star::awt::SystemPointer values.

## ◆ startShapeActivity()

boolean startShapeActivity | ( | [in] ::com::sun::star::drawing::XShape | xShape | ) |

Start a shape-intrinsic animation or activity.

This method starts an animation or activity intrinsic to the given shape. Shape-intrinsic activities are things like video playback for multimedia shapes, sounds, GIF animations and drawing layer animations (flipping between shapes in a group, or scroll text).

Parameters

  xShape | The shape to start the activity for

## ◆ stopShapeActivity()

boolean stopShapeActivity | ( | [in] ::com::sun::star::drawing::XShape | xShape | ) |

Stop a shape-intrinsic animation or activity.

This method stops an animation or activity intrinsic to the given shape. Shape-intrinsic activities are things like video playback for multimedia shapes, sounds, GIF animations and drawing layer animations (flipping between shapes in a group, or scroll text).

Parameters

  xShape | The shape to stop the activity for

## ◆ update()

boolean update | ( | [out] double | nNextTimeout | ) |

Update the animations.

This method updates all currently active slide animations. The XSlideShow implementations do not render animations automatically, but must be called from their clients. This allows for various update mechanisms to be employed, ranging from a dedicated rendering thread, over timer-based updates, to rendering in an idle function. Either way, the client of this interface decide about the details.

Parameters

  nNextTimeout | Via this value, the implementation can return a timeout value, denoting the maximal time span that must not be exceeded from the return of this method to the next update call. Otherwise, the animations might show visible jerks.

Returns
  `TRUE`, if further update calls are required. If `FALSE` is returned, no further update calls are necessary, until anyone of the other interface methods is called (most notably, the next/previousSlide(), nextEffect() and show() methods will nearly always make further update() calls necessary).

The documentation for this interface was generated from the following file:

- com/sun/star/presentation/XSlideShow.idl